Loading...
Searching...
No Matches
Debug
SPA

Debugging utilities. More...

## Files

file | buffer.h
| spa/debug/buffer.h
file | context.h
| spa/debug/context.h
file | dict.h
| spa/debug/dict.h
file | file.h
| spa/debug/file.h
file | format.h
| spa/debug/format.h
file | log.h
| spa/debug/log.h
file | mem.h
| spa/debug/mem.h
file | node.h
| spa/debug/node.h
file | pod.h
| spa/debug/pod.h
file | types.h
| spa/debug/types.h

## Data Structures

struct | spa_debug_context
struct | spa_debug_file_ctx
struct | spa_debug_log_ctx

## Macros

#define | SPA_API_DEBUG_BUFFER static inline
#define | spa_debugn(_fmt, ...)
#define | spa_debug(_fmt, ...)
#define | SPA_API_DEBUG_CONTEXT static inline
#define | spa_debugc(_c, _fmt, ...)
#define | SPA_API_DEBUG_DICT static inline
#define | SPA_API_DEBUG_FILE static inline
#define | SPA_DEBUG_FILE_INIT(_f)
#define | spa_debug_file_error_location(f, loc, fmt, ...)
#define | SPA_API_DEBUG_FORMAT static inline
#define | SPA_LOGF_DEBUG_INIT(_l, _lev, _t, _file, _line, _func)
#define | SPA_LOGT_DEBUG_INIT(_l, _lev, _t)
#define | SPA_LOG_DEBUG_INIT(l, lev)
#define | spa_debug_log_pod(l, lev, indent, info, pod)
#define | spa_debug_log_format(l, lev, indent, info, format)
#define | spa_debug_log_mem(l, lev, indent, data, len)
#define | spa_debug_log_dict(l, lev, indent, dict)
#define | spa_debug_log_error_location(l, lev, loc, fmt, ...)
#define | SPA_API_DEBUG_MEM static inline
#define | SPA_API_DEBUG_NODE static inline
#define | SPA_API_DEBUG_POD static inline
#define | SPA_API_DEBUG_TYPES static inline

## Functions

SPA_API_DEBUG_BUFFER int | spa_debugc_buffer (struct spa_debug_context *ctx, int indent, const struct spa_buffer *buffer)
SPA_API_DEBUG_BUFFER int | spa_debug_buffer (int indent, const struct spa_buffer *buffer)
SPA_API_DEBUG_CONTEXT void | spa_debugc_error_location (struct spa_debug_context *c, struct spa_error_location *loc)
SPA_API_DEBUG_DICT int | spa_debugc_dict (struct spa_debug_context *ctx, int indent, const struct spa_dict *dict)
SPA_API_DEBUG_DICT int | spa_debug_dict (int indent, const struct spa_dict *dict)
SPA_API_DEBUG_FILE void | spa_debug_file_log (struct spa_debug_context *ctx, const char *fmt,...)
SPA_API_DEBUG_FORMAT int | spa_debug_strbuf_format_value (struct spa_strbuf *buffer, const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
SPA_API_DEBUG_FORMAT int | spa_debug_format_value (const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
SPA_API_DEBUG_FORMAT int | spa_debugc_format (struct spa_debug_context *ctx, int indent, const struct spa_type_info *info, const struct spa_pod *format)
SPA_API_DEBUG_FORMAT int | spa_debug_format (int indent, const struct spa_type_info *info, const struct spa_pod *format)
SPA_API_DEBUG_LOG void | spa_debug_log_log (struct spa_debug_context *ctx, const char *fmt,...)
SPA_API_DEBUG_MEM int | spa_debugc_mem (struct spa_debug_context *ctx, int indent, const void *data, size_t size)
SPA_API_DEBUG_MEM int | spa_debug_mem (int indent, const void *data, size_t size)
SPA_API_DEBUG_NODE int | spa_debugc_port_info (struct spa_debug_context *ctx, int indent, const struct spa_port_info *info)
SPA_API_DEBUG_NODE int | spa_debug_port_info (int indent, const struct spa_port_info *info)
SPA_API_DEBUG_POD int | spa_debugc_pod_value (struct spa_debug_context *ctx, int indent, const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
SPA_API_DEBUG_POD int | spa_debugc_pod (struct spa_debug_context *ctx, int indent, const struct spa_type_info *info, const struct spa_pod *pod)
SPA_API_DEBUG_POD int | spa_debug_pod_value (int indent, const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
SPA_API_DEBUG_POD int | spa_debug_pod (int indent, const struct spa_type_info *info, const struct spa_pod *pod)
SPA_API_DEBUG_TYPES const struct spa_type_info * | spa_debug_type_find (const struct spa_type_info *info, uint32_t type)
SPA_API_DEBUG_TYPES const char * | spa_debug_type_short_name (const char *name)
SPA_API_DEBUG_TYPES const char * | spa_debug_type_find_name (const struct spa_type_info *info, uint32_t type)
SPA_API_DEBUG_TYPES const char * | spa_debug_type_find_short_name (const struct spa_type_info *info, uint32_t type)
SPA_API_DEBUG_TYPES uint32_t | spa_debug_type_find_type (const struct spa_type_info *info, const char *name)
SPA_API_DEBUG_TYPES const struct spa_type_info * | spa_debug_type_find_short (const struct spa_type_info *info, const char *name)
SPA_API_DEBUG_TYPES uint32_t | spa_debug_type_find_type_short (const struct spa_type_info *info, const char *name)

## Detailed Description

Debugging utilities.

## Macro Definition Documentation

## SPA_API_DEBUG_BUFFER

#define SPA_API_DEBUG_BUFFER static inline

## spa_debugn

#define spa_debugn | ( |  | _fmt,
|  |  | ... )

Value:
printf((_fmt), ## __VA_ARGS__)

## spa_debug

#define spa_debug | ( |  | _fmt,
|  |  | ... )

Value:
spa_debugn(_fmt"\n", ## __VA_ARGS__)
spa_debugn
#define spa_debugn(_fmt,...)
Definition context.h:29

## SPA_API_DEBUG_CONTEXT

#define SPA_API_DEBUG_CONTEXT static inline

## spa_debugc

#define spa_debugc | ( |  | _c,
|  |  | _fmt,
|  |  | ... )

Value:
(_c)?((_c)->log((_c),_fmt, ## __VA_ARGS__)):(void)spa_debug(_fmt, ## __VA_ARGS__)
spa_debug
#define spa_debug(_fmt,...)
Definition context.h:32

## SPA_API_DEBUG_DICT

#define SPA_API_DEBUG_DICT static inline

## SPA_API_DEBUG_FILE

#define SPA_API_DEBUG_FILE static inline

## SPA_DEBUG_FILE_INIT

#define SPA_DEBUG_FILE_INIT | ( |  | _f | ) |

Value:
(struct spa_debug_file_ctx){ { spa_debug_file_log }, _f, }
spa_debug_file_log
SPA_API_DEBUG_FILE void spa_debug_file_log(struct spa_debug_context *ctx, const char *fmt,...)
Definition file.h:50
spa_debug_file_ctx
Definition file.h:44

## spa_debug_file_error_location

#define spa_debug_file_error_location | ( |  | f,
|  |  | loc,
|  |  | fmt,
|  |  | ... )

## SPA_API_DEBUG_FORMAT

#define SPA_API_DEBUG_FORMAT static inline

## SPA_LOGF_DEBUG_INIT

#define SPA_LOGF_DEBUG_INIT | ( |  | _l,
|  |  | _lev,
|  |  | _t,
|  |  | _file,
|  |  | _line,
|  |  | _func )

## SPA_LOGT_DEBUG_INIT

#define SPA_LOGT_DEBUG_INIT | ( |  | _l,
|  |  | _lev,
|  |  | _t )

Value:
SPA_LOGF_DEBUG_INIT(_l,_lev,_t,__FILE__,__LINE__,__func__)
SPA_LOGF_DEBUG_INIT
#define SPA_LOGF_DEBUG_INIT(_l, _lev, _t, _file, _line, _func)
Definition log.h:63

## SPA_LOG_DEBUG_INIT

#define SPA_LOG_DEBUG_INIT | ( |  | l,
|  |  | lev )

Value:
SPA_LOGT_DEBUG_INIT(l,lev,SPA_LOG_TOPIC_DEFAULT)
SPA_LOGT_DEBUG_INIT
#define SPA_LOGT_DEBUG_INIT(_l, _lev, _t)
Definition log.h:67
SPA_LOG_TOPIC_DEFAULT
#define SPA_LOG_TOPIC_DEFAULT
The default log topic.
Definition log.h:53

## spa_debug_log_pod

#define spa_debug_log_pod | ( |  | l,
|  |  | lev,
|  |  | indent,
|  |  | info,
|  |  | pod )

## spa_debug_log_format

#define spa_debug_log_format | ( |  | l,
|  |  | lev,
|  |  | indent,
|  |  | info,
|  |  | format )

## spa_debug_log_mem

#define spa_debug_log_mem | ( |  | l,
|  |  | lev,
|  |  | indent,
|  |  | data,
|  |  | len )

## spa_debug_log_dict

#define spa_debug_log_dict | ( |  | l,
|  |  | lev,
|  |  | indent,
|  |  | dict )

## spa_debug_log_error_location

#define spa_debug_log_error_location | ( |  | l,
|  |  | lev,
|  |  | loc,
|  |  | fmt,
|  |  | ... )

## SPA_API_DEBUG_MEM

#define SPA_API_DEBUG_MEM static inline

## SPA_API_DEBUG_NODE

#define SPA_API_DEBUG_NODE static inline

## SPA_API_DEBUG_POD

#define SPA_API_DEBUG_POD static inline

## SPA_API_DEBUG_TYPES

#define SPA_API_DEBUG_TYPES static inline

## Function Documentation

## spa_debugc_buffer()

SPA_API_DEBUG_BUFFER int spa_debugc_buffer | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_buffer * | buffer )

## spa_debug_buffer()

SPA_API_DEBUG_BUFFER int spa_debug_buffer | ( | int | indent,
|  | const struct spa_buffer * | buffer )

## spa_debugc_error_location()

SPA_API_DEBUG_CONTEXT void spa_debugc_error_location | ( | struct spa_debug_context * | c,
|  | struct spa_error_location * | loc )

## spa_debugc_dict()

SPA_API_DEBUG_DICT int spa_debugc_dict | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_dict * | dict )

## spa_debug_dict()

SPA_API_DEBUG_DICT int spa_debug_dict | ( | int | indent,
|  | const struct spa_dict * | dict )

Examples
  bluez-session.c.

## spa_debug_file_log()

SPA_API_DEBUG_FILE void spa_debug_file_log | ( | struct spa_debug_context * | ctx,
|  | const char * | fmt,
|  |  | ... )

## spa_debug_strbuf_format_value()

SPA_API_DEBUG_FORMAT int spa_debug_strbuf_format_value | ( | struct spa_strbuf * | buffer,
|  | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size )

## spa_debug_format_value()

SPA_API_DEBUG_FORMAT int spa_debug_format_value | ( | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size )

## spa_debugc_format()

SPA_API_DEBUG_FORMAT int spa_debugc_format | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | format )

## spa_debug_format()

SPA_API_DEBUG_FORMAT int spa_debug_format | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | format )

Examples
  export-sink.c, export-source.c, video-play-fixate.c, video-play-pull.c, video-play-reneg.c, video-play-sync.c, video-play.c, video-src-fixate.c, video-src-sync.c, and video-src.c.

## spa_debug_log_log()

SPA_API_DEBUG_LOG void spa_debug_log_log | ( | struct spa_debug_context * | ctx,
|  | const char * | fmt,
|  |  | ... )

## spa_debugc_mem()

SPA_API_DEBUG_MEM int spa_debugc_mem | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const void * | data,
|  | size_t | size )

## spa_debug_mem()

SPA_API_DEBUG_MEM int spa_debug_mem | ( | int | indent,
|  | const void * | data,
|  | size_t | size )

## spa_debugc_port_info()

SPA_API_DEBUG_NODE int spa_debugc_port_info | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_port_info * | info )

## spa_debug_port_info()

SPA_API_DEBUG_NODE int spa_debug_port_info | ( | int | indent,
|  | const struct spa_port_info * | info )

## spa_debugc_pod_value()

SPA_API_DEBUG_POD int spa_debugc_pod_value | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size )

## spa_debugc_pod()

SPA_API_DEBUG_POD int spa_debugc_pod | ( | struct spa_debug_context * | ctx,
|  | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | pod )

## spa_debug_pod_value()

SPA_API_DEBUG_POD int spa_debug_pod_value | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size )

## spa_debug_pod()

SPA_API_DEBUG_POD int spa_debug_pod | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | pod )

Examples
  local-v4l2.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, spa/examples/local-v4l2.c, spa/examples/local-videotestsrc.c, video-dsp-src.c, video-play-fixate.c, video-play-sync.c, video-play.c, video-src-fixate.c, video-src-sync.c, and video-src.c.

## spa_debug_type_find()

SPA_API_DEBUG_TYPES const struct spa_type_info * spa_debug_type_find | ( | const struct spa_type_info * | info,
|  | uint32_t | type )

## spa_debug_type_short_name()

SPA_API_DEBUG_TYPES const char * spa_debug_type_short_name | ( | const char * | name | ) |

## spa_debug_type_find_name()

SPA_API_DEBUG_TYPES const char * spa_debug_type_find_name | ( | const struct spa_type_info * | info,
|  | uint32_t | type )

Examples
  tutorial5.c.

## spa_debug_type_find_short_name()

SPA_API_DEBUG_TYPES const char * spa_debug_type_find_short_name | ( | const struct spa_type_info * | info,
|  | uint32_t | type )

## spa_debug_type_find_type()

SPA_API_DEBUG_TYPES uint32_t spa_debug_type_find_type | ( | const struct spa_type_info * | info,
|  | const char * | name )

## spa_debug_type_find_short()

SPA_API_DEBUG_TYPES const struct spa_type_info * spa_debug_type_find_short | ( | const struct spa_type_info * | info,
|  | const char * | name )

## spa_debug_type_find_type_short()

SPA_API_DEBUG_TYPES uint32_t spa_debug_type_find_type_short | ( | const struct spa_type_info * | info,
|  | const char * | name )